
public class LinkedList<E> 
{

	// should be private --  public to illustrate a point
	public ListNode firstNode;
	private int size;

	public LinkedList() 
	{
		firstNode = null;
		size = 0;
	}

	public void replaceNode(int index, E e)
	{
		if (index < 0 || index > size) 
		{
			throw new IndexOutOfBoundsException();
		}

		ListNode newNode = new ListNode(e);
		
		if (index == 0) 
		{
			newNode.nextNode = firstNode.nextNode;
			firstNode = newNode;
		}
		else 
		{
			ListNode curNode = firstNode;
			for (int i = 0; i < index - 1; i++) 
			{
				curNode = curNode.nextNode;
			}
			// curNode is at index-1
			newNode.nextNode = curNode.nextNode.nextNode;
			curNode.nextNode = newNode;
		}
	}
	
	
	public boolean add(E e) 
	{

		ListNode newNode = new ListNode(e);

		if (size == 0) 
		{
			firstNode = newNode;
		} else 
		{
			ListNode curNode = firstNode;

			while (curNode.nextNode != null) 
			{
				curNode = curNode.nextNode;
			}
			// curNode = last node in our list
			curNode.nextNode = newNode;
		}

		size++;

		return true;
	}

	public void add(int index, E e) 
	{

		if (index < 0 || index > size) 
		{
			throw new IndexOutOfBoundsException();
		}

		ListNode newNode = new ListNode(e);

		if (index == 0) 
		{
			newNode.nextNode = firstNode;
			firstNode = newNode;
		} else 
		{
			ListNode curNode = firstNode;
			for (int i = 0; i < index - 1; i++) 
			{
				curNode = curNode.nextNode;
			}
			// curNode is at index-1
			newNode.nextNode = curNode.nextNode;
			curNode.nextNode = newNode;
		}

		size++;

	}

	public E remove() 
	{
		return remove(0);
	}

	public E remove(int index) 
	{

		if (index < 0 || index >= size) 
		{
			throw new IndexOutOfBoundsException();
		}

		E toReturn;
		if (index == 0) 
		{
			toReturn = firstNode.value;
			firstNode = firstNode.nextNode;
		} 
		else 
		{
			ListNode curNode = firstNode;
			for (int i = 0; i < index - 1; i++) 
			{
				curNode = curNode.nextNode;
			}
			// curNode is at index-1
			toReturn = curNode.nextNode.value;
			curNode.nextNode = curNode.nextNode.nextNode;
		}

		size--;

		return toReturn;
	}

	public boolean remove(E e) 
	{

		if (firstNode == null) 
		{
			return false;
		} 
		else if (firstNode.value.equals(e)) 
		{
			firstNode = firstNode.nextNode;
			size--;
			return true;
		} 
		else 
		{
			ListNode curNode = firstNode;
			while (curNode.nextNode != null && !curNode.nextNode.value.equals(e)) 
			{
				curNode = curNode.nextNode;
			}

			// curNode is just before the node we want to remove
			// curNode is the last node --> e does not exist in the list
			if (curNode.nextNode == null) 
			{
				return false;
			} 
			else 
			{
				curNode.nextNode = curNode.nextNode.nextNode;
				size--;
				return true;
			}
		}

	}

	public void print()
	{
		System.out.println("\nList contents:");
		ListNode nodePtr = firstNode;
		while(nodePtr != null)
		{
			System.out.println(nodePtr.value);
			nodePtr = nodePtr.nextNode;
		}
		System.out.println();
	}
	
	public class ListNode 
	{

		private E value;
		private ListNode nextNode;

		public ListNode(E e) 
		{
			value = e;
			nextNode = null;
		}

		public void setNext(ListNode next) 
		{
			nextNode = next;
		}

		public ListNode getNext() 
		{
			return nextNode;
		}

		public E getValue() 
		{
			return value;
		}
	}

}
